--1. Z tabulky JEDNOTKY zobraz sloupce JEDNOTKA, PODIL_CITTEL, PODIL_JMENOVATEL pro vechny zznamy 
--   setdn podle sloupce JEDNOTKA 
SELECT JEDNOTKA, PODIL_CITATEL, PODIL_JMENOVATEL FROM JEDNOTKY ORDER BY JEDNOTKA ASC;

--2. Z tabulky JEDNOTKY zobraz sloupce ID_TYP_JEDNOTKY, JEDNOTKA, PODIL_CITTEL, 
--   PODIL_JMENOVATEL pro zznamy kde ID_TYP_JEDNOTKY = 1 (byt) setdn podle sloupce JEDNOTKA
SELECT ID_TYP_JEDNOTKY, JEDNOTKA, PODIL_CITATEL, PODIL_JMENOVATEL FROM JEDNOTKY WHERE ID_TYP_JEDNOTKY = 1  
ORDER BY JEDNOTKA ASC;

--3. Z tabulky JEDNOTKY zobraz sloupce ID_TYP_JEDNOTKY, JEDNOTKA, PODIL_CITTEL, 
--   PODIL_JMENOVATEL pro zznamy kde ID_TYP_JEDNOTKY nerovn se 1 (byt).
SELECT ID_TYP_JEDNOTKY, JEDNOTKA, PODIL_CITATEL, PODIL_JMENOVATEL FROM JEDNOTKY WHERE ID_TYP_JEDNOTKY != 1;

--4. Zobraz tabulku JEDNOTKY, kam pid sloupec PODIL_DES. V tomto sloupci bude podl jednotky vyjden 
--   jako desetinn slo.
SELECT JEDNOTKY.VCHOD, JEDNOTKY.JEDNOTKA, JEDNOTKY.PODIL_CITATEL, JEDNOTKY.PODIL_JMENOVATEL, 
PODIL_CITATEL/PODIL_JMENOVATEL AS PODIL_DES
FROM JEDNOTKY
ORDER BY JEDNOTKA ASC;

--5. Vyber vechny jednotky a vlastnky, jejich jednotka, kterou vlastn, se dl na dly s 
--   podlem 1/4 (parkovac stn s parkliftem pro 4 vozy). Zznamy omezte pouze na platn vlastnictv.
SELECT JEDNOTKY.JEDNOTKA, DIL.CISLO_STANI, OSOBY.OSOBA
FROM OSOBY INNER JOIN ((JEDNOTKY 
INNER JOIN DIL ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
INNER JOIN VLASTNICTVI ON DIL.ID_DIL = VLASTNICTVI.ID_DIL) 
ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY
WHERE ((VLASTNICTVI.Platnost=1) AND (DIL.PODIL_CITATEL=1) AND (DIL.PODIL_JMENOVATEL=4))
ORDER BY JEDNOTKY.JEDNOTKA;

--6. spojen - JOIN ON: spojen tabulek JEDNOTKY a TYP_JEDNOTKY_CIS, kde se rovnaj zznamy ve sloupcch 
--   ID_TYP_JEDNOTKY.
SELECT JEDNOTKY.JEDNOTKA, JEDNOTKY.PODIL_CITATEL, JEDNOTKY.PODIL_JMENOVATEL, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY 
FROM TYP_JEDNOTKY_CIS INNER JOIN JEDNOTKY ON TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY = JEDNOTKY.ID_TYP_JEDNOTKY;

--7. spojen - NATURAL JOIN: Vem jednotkm je piazen typ jednotky z tabulky TYP_JEDNOTKY_CIS, 
--   kter je pouvna jako selnk
SELECT JEDNOTKY.JEDNOTKA, JEDNOTKY.PODIL_CITATEL, JEDNOTKY.PODIL_JMENOVATEL, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY 
FROM TYP_JEDNOTKY_CIS  
NATURAL JOIN JEDNOTKY;

--8. Kombinace vech jednotek a osob.
SELECT JEDNOTKY.JEDNOTKA, OSOBY.OSOBA FROM JEDNOTKY CROSS JOIN OSOBY
WHERE JEDNOTKY.JEDNOTKA < 5
;

--9. Vybere vechna vlastnictv, kter nevlastn dn osoba - takov zznamy v databzi nejsou (nemaj smysl)
SELECT OSOBY.ID_OSOBY, VLASTNICTVI.ID_VLASTNICTVI, VLASTNICTVI.ID_DIL 
FROM OSOBY 
RIGHT JOIN VLASTNICTVI ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY 
WHERE OSOBY.ID_OSOBY Is Null;

--10. Vybere vechny osoby, kter nemaj dn vlastnictv - takov zznamy v databzi tek nejsou 
--    (opt nemaj smysl).
SELECT OSOBY.ID_OSOBY, VLASTNICTVI.ID_VLASTNICTVI, VLASTNICTVI.ID_DIL 
FROM OSOBY LEFT 
JOIN VLASTNICTVI ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY 
WHERE VLASTNICTVI.ID_VLASTNICTVI Is Null;

--11. Vybere vechny osoby, kter maj nebo nemaj njak vlastnictv a vlastnictv, kter maj 
--    nebo nemaj vlastnky - vzhledem k vsledkm dotaz 9 a 10, tak ten dotaz ned jin vsledky ne pirozen spojen).</para
SELECT OSOBY.ID_OSOBY,OSOBY.OSOBA, VLASTNICTVI.ID_VLASTNICTVI, VLASTNICTVI.ID_DIL 
FROM OSOBY 
FULL JOIN VLASTNICTVI ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY;


--12. Ke kad jednotce zobraz aktulnho vlastnka.
SELECT JEDNOTKY.VCHOD, JEDNOTKY.JEDNOTKA, DIL.CISLO_STANI, VLASTNICTVI.DATUM_PREVZETI, VLASTNICTVI.DATUM_PREDANI, 
VLASTNICTVI.PLATNOST, OSOBY.OSOBA 
FROM ((JEDNOTKY INNER JOIN DIL ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
INNER JOIN VLASTNICTVI ON DIL.ID_DIL = VLASTNICTVI.ID_DIL ) 
INNER JOIN OSOBY ON VLASTNICTVI.ID_OSOBY = OSOBY.ID_OSOBY 
WHERE VLASTNICTVI.PLATNOST = 1 
ORDER BY JEDNOTKY.JEDNOTKA, DIL.CISLO_STANI ;

--13. Vybere jednotku s nejvtm podlem na budov. Podl je nutno pevst na desetinn slo a vybrat to nejvt.
SELECT DISTINCT VCHOD, JEDNOTKA, PODIL_CITATEL, PODIL_JMENOVATEL
FROM JEDNOTKY 
WHERE 
PODIL_CITATEL/PODIL_JMENOVATEL 
IN 
(SELECT Max(PODIL_CITATEL/PODIL_JMENOVATEL)
FROM 
JEDNOTKY);

--14. Vybere jednotky, jejich ID je men ne 15 a k nim pid jednotky jejich slo jednotk y je vy ne 100.
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE ID_JEDNOTKY < 15
UNION
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE JEDNOTKA > 100;

--15. Od jednotek jejich ID je men ne 150 odete vechny jednotky jejich ID je vt ne 100.
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE ID_JEDNOTKY < 150
MINUS
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE ID_JEDNOTKY > 100;

--16. Vybere jednotky, kter jsou v mnoin jednotek jejich ID je men ne 150 a zrove jsou v mnoin 
--    jednotek jejich ID je vt ne 100.
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE ID_JEDNOTKY < 150
INTERSECT
SELECT ID_JEDNOTKY, JEDNOTKA FROM JEDNOTKY WHERE ID_JEDNOTKY > 100;

--17. Vybere jednotkY jej podl na budov je men ne prmrn podl vech jednotek. Podl je nutno 
--    pevst na desetinn slo.
SELECT DISTINCT VCHOD, JEDNOTKA, PODIL_CITATEL, PODIL_JMENOVATEL
FROM JEDNOTKY 
WHERE 
PODIL_CITATEL/PODIL_JMENOVATEL 
< 
(SELECT AVG(PODIL_CITATEL/PODIL_JMENOVATEL)
FROM 
JEDNOTKY);

--18. Jak je poet jednotek? 
SELECT Count(ID_JEDNOTKY) AS POCET_JEDNOTEK
FROM JEDNOTKY;

--19. Poet velikost jednotek (rznch podl).
CREATE VIEW SEZNAM_PODILU AS
SELECT PODIL_CITATEL, PODIL_JMENOVATEL
FROM JEDNOTKY
GROUP BY PODIL_CITATEL, PODIL_JMENOVATEL;

SELECT Count(
PODIL_CITATEL)
FROM SEZNAM_PODILU;

--20. Stejn jako pedchoz.
SELECT Count (*) FROM (
SELECT PODIL_CITATEL, PODIL_JMENOVATEL
FROM JEDNOTKY
GROUP BY PODIL_CITATEL, PODIL_JMENOVATEL)  POCET_PODILU;

--21. Vyber vechny osoby, kter vlastn vechny typy jednotek.
-- SEZNAM OSOB,KTER MAJ VECHNO
SELECT DISTINCT OSOBA
FROM(
-- SEZNAM VECH OSOB
(SELECT DISTINCT OSOBA 
FROM OSOBY)
MINUS
-- SEZNAM OBOB, KTER NCO NEMAJ
(SELECT DISTINCT OSOBA 
FROM(
-- SEZNAM CO KDO NEM
SELECT OSOBA, TYP_JEDNOTKY
FROM
-- OD MONHO ODETE CO JE A DOSTANE CO NEN
(SELECT DISTINCT OSOBA, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY
FROM 
-- KARTZSK SOUIN, TJ. CO JE MON
(SELECT DISTINCT OSOBY.OSOBA, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY
FROM TYP_JEDNOTKY_CIS 
INNER JOIN (JEDNOTKY 
INNER JOIN (DIL 
INNER JOIN (OSOBY 
INNER JOIN VLASTNICTVI 
ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY) 
ON DIL.ID_DIL = VLASTNICTVI.ID_DIL) 
ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
ON TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY = JEDNOTKY.ID_TYP_JEDNOTKY
), TYP_JEDNOTKY_CIS
ORDER BY OSOBA)
MINUS
-- ODETE CO JE V TABULCE (SKUTENOST)
(SELECT DISTINCT OSOBY.OSOBA, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY
FROM TYP_JEDNOTKY_CIS 
INNER JOIN (JEDNOTKY 
INNER JOIN (DIL 
INNER JOIN (OSOBY 
INNER JOIN VLASTNICTVI 
ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY) 
ON DIL.ID_DIL = VLASTNICTVI.ID_DIL) 
ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
ON TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY = JEDNOTKY.ID_TYP_JEDNOTKY))));

--22. Vyber vechny osoby, kter vlastn vechny typy jednotek. 
--    Pouito zda vlastn jednotky tolika typ jednotek, kolik jich je 
--    v selnku typu jednotky.
-- ZJIST OBOBY, KTER VLASTN VECHNY TYPY JEDNOTEK, JIN ZPSOB
SELECT OSOBA, POCET
FROM (
-- Spojeni TYP_JEDNOTKY - JEDNOTKA - DIL - VLASTNICTVI - OSOBA:
SELECT OSOBA, COUNT(OSOBA) AS POCET
FROM (
SELECT DISTINCT OSOBY.OSOBA, TYP_JEDNOTKY_CIS.TYP_JEDNOTKY
FROM TYP_JEDNOTKY_CIS 
INNER JOIN (JEDNOTKY 
INNER JOIN (DIL 
INNER JOIN (OSOBY 
INNER JOIN VLASTNICTVI 
ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY) 
ON DIL.ID_DIL = VLASTNICTVI.ID_DIL) 
ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
ON TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY = JEDNOTKY.ID_TYP_JEDNOTKY)
GROUP BY OSOBA)
-- POROVN POET S POTEM ZZNAM V TYP_JEDNOTKY_CIS
WHERE POCET = (
-- ZJIST POET ZZNAM V TYP_JEDNOTKY_CIS
SELECT COUNT (TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY)
FROM TYP_JEDNOTKY_CIS);

--23. Vyber OSOBY, kter nevlastn dn sklep.
SELECT DISTINCT OSOBY.OSOBA
FROM TYP_JEDNOTKY_CIS 
INNER JOIN (JEDNOTKY 
INNER JOIN (DIL 
INNER JOIN (OSOBY 
INNER JOIN VLASTNICTVI 
ON OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY) 
ON DIL.ID_DIL = VLASTNICTVI.ID_DIL) 
ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY) 
ON TYP_JEDNOTKY_CIS.ID_TYP_JEDNOTKY = JEDNOTKY.ID_TYP_JEDNOTKY
WHERE TYP_JEDNOTKY <> 'sklep';

--24. O kolik se li poet osob,kter jsou SJM a kter nejsou SJM.
-- ABSOLUTN ROZDL MEZI SJM A NESJM
SELECT DISTINCT 
-- ABSOLUTN HODNOTA
ABS((
-- ROZDL SJM MNUS NESJM
SELECT COUNT(SJM) AS POCET_SJM
FROM(
-- OSOBY, KTER JSOU SJM
SELECT OSOBA AS SJM
FROM OSOBY
WHERE OSOBA LIKE 'SJM%'))
-
-- POET NESJM
(SELECT COUNT(NESJM) AS POCET_NESJM
FROM(
-- OSOBY, KTER NEJSOU SJM
SELECT OSOBA AS NESJM
FROM OSOBY
WHERE OSOBA NOT LIKE 'SJM%')))
AS ROZDIL
FROM OSOBY;

-- 25. Seznam osob, kter nemaj dn platn vlastnictv.
-- SEZNAM VECH OSOB
SELECT * 
FROM OSOBY
WHERE NOT EXISTS (
-- SEZNAM OBOS, KTER NEMAJ PLATN VLASTNICTV
SELECT * FROM VLASTNICTVI
WHERE OSOBY.ID_OSOBY = VLASTNICTVI.ID_OSOBY AND VLASTNICTVI.PLATNOST = 1
);

-- 26. Seznam osob, kter nemaj dn platn vlastnictv.
SELECT OSOBA
FROM(
SELECT DISTINCT OSOBA
FROM OSOBY 
NATURAL JOIN VLASTNICTVI
WHERE VLASTNICTVI.PLATNOST = 0)
MINUS(
SELECT DISTINCT OSOBA
FROM OSOBY
NATURAL JOIN VLASTNICTVI
WHERE VLASTNICTVI.PLATNOST = 1 
);

-- 27. Seznam osob, kter nemaj dn platn vlastnictv.
SELECT OSOBA
FROM(
SELECT DISTINCT OSOBA
FROM OSOBY )
MINUS(
SELECT DISTINCT OSOBA
FROM OSOBY
NATURAL JOIN VLASTNICTVI
WHERE VLASTNICTVI.PLATNOST = 1 
);

-- 28. Vytvoit pohled platnch vlastnictv.
CREATE VIEW PLATNA_VLASTNICTVI AS
SELECT * 
FROM VLASTNICTVI
WHERE VLASTNICTVI.PLATNOST = 1;

-- 29. Kter OSOBY vlastn kter jednotky - jen platn vlastnictv.
SELECT JEDNOTKY.JEDNOTKA, DIL.CISLO_STANI, OSOBY.OSOBA
FROM(
JEDNOTKY
INNER JOIN (DIL
INNER JOIN (PLATNA_VLASTNICTVI
INNER JOIN OSOBY
ON PLATNA_VLASTNICTVI.ID_OSOBY = OSOBY.ID_OSOBY)
ON DIL.ID_DIL = PLATNA_VLASTNICTVI.ID_DIL)
ON JEDNOTKY.ID_JEDNOTKY = DIL.ID_JEDNOTKY)
ORDER BY OSOBY.OSOBA, JEDNOTKY.JEDNOTKA;

--30. Vytvo tabulku platnch vlastnictv. Do n zkopruje zznamy platnch 
--    vlastnictv a do sloupce SUMA vlo nuly.
DROP TABLE VLASTNICTVI_PLATNA_TAB;

Create table VLASTNICTVI_PLATNA_TAB (
      ID_DIL Integer,
      ID_TYP Integer,
      ID_OSOBY Integer ,
      DATUM_PREVZETI Date ,
      DATUM_PREDANI Date ,
      PLATNOST Integer,
      SUMA Integer
);

INSERT INTO VLASTNICTVI_PLATNA_TAB 
(ID_OSOBY, ID_TYP, ID_DIL, DATUM_PREVZETI, DATUM_PREDANI, PLATNOST, SUMA )
SELECT VLASTNICTVI.ID_OSOBY, 
       VLASTNICTVI.ID_TYP, 
       VLASTNICTVI.ID_DIL, 
       VLASTNICTVI.DATUM_PREVZETI, 
       VLASTNICTVI.DATUM_PREDANI, 
       VLASTNICTVI.PLATNOST, 
       0 AS SUMA
FROM   VLASTNICTVI
WHERE PLATNOST = 1
;

--31. Do sloupce SUMA vlo souet hodnot soupce ID_TYP.
UPDATE VLASTNICTVI_PLATNA_TAB
SET VLASTNICTVI_PLATNA_TAB.ID_TYP = (
SELECT SUM(VLASTNICTVI_PLATNA_TAB.ID_TYP) AS SUMA
FROM VLASTNICTVI_PLATNA_TAB);

--32. Z tabulky .VLASTNICTVI_PLATNA_TAB odstran zznamy o vlastnictv osoby, kter jsou SJM
DELETE FROM VLASTNICTVI_PLATNA_TAB
WHERE VLASTNICTVI_PLATNA_TAB.ID_OSOBY IN(
SELECT ID_OSOBY
FROM OSOBY
WHERE OSOBA LIKE 'SJM%');